;-----------------------------------------------------------------------
; DateiName        :  quad.asm
;-----------------------------------------------------------------------
; Autor            :  Christian Rsch
;
; Erstellungsdatum :  25.11.2001
;-----------------------------------------------------------------------
; Info :  Dieses Programm malt auf jeden Fall ein Quadrat, aber es sind
;         noch ein paar Extras in Planung
;-----------------------------------------------------------------------

; Dies ist das Daten-Segment

data SEGMENT
assume DS:data
                ;ziemlich leer heut...
data ends



; Dies ist das Stack-Segment

stackdata SEGMENT stack
assume SS:stackdata
        db 256 dup(?)           ; definiert die Grsse des Stacks
stackdata ends



; Dies ist das Code-Segment

code SEGMENT
ASSUME CS:code

;-----------------------------------------------------------------------
; Funktion        : palette
;-----------------------------------------------------------------------
; Info : erzeugt einen Farbverlauf in den ersten 32 Farbeintrgen
;-----------------------------------------------------------------------
; IN  : ---
; OUT : AX,CX,DX: unknown
;-----------------------------------------------------------------------
palette PROC
                mov     dx,3c8h         ;prepare Palette
                xor     al,al
                xor     cl,cl
                out     dx,al
                inc     dx
                out     dx,al
                out     dx,al
                out     dx,al           ; einmal Schwarz
                mov     al,18
                out     dx,al
                out     dx,al
                mov     al,63
                out     dx,al           ; einmal Blau
                inc     cl
palette_1:
                mov     al,cl
                shr     al,2
                out     dx,al
                mov     al,cl
                shl     al,1
                out     dx,al
                mov     al,cl
                shr     al,1
                out     dx,al
                inc     cl
                cmp     cl,32
                jnz     palette_1
        ret
ENDP
;-----------------------------------------------------------------------
; Funktion        : coolfx
;-----------------------------------------------------------------------
; Info : malt den Landschaftseffekt in das Quadrat
;-----------------------------------------------------------------------
; IN  : SI: Zeile der Landschaft
; OUT : ax,bx,dx,di,si,bp,es: unknown
;-----------------------------------------------------------------------
zbuf      db 98 dup(?)           ; Z-Buffer des Effekts
label landscape byte            ; Landschaft
include c:\oldskool\codes\scape.asm
coolfx PROC

       mov  di,0               ; z-Buffer lschen
cfx_l1:
       mov  [zbuf+di],20
       inc  di
       cmp  di,98
       jnz  cfx_l1

       push 0a000h              ; VGA-Segment
       pop  es

       mov  di,148*320+208      ; Pixel auf dem Bildschirm
       add  si,97*128           ; letzte Zeile im Landschaftarray

       mov  bp,97               ; Spalte 98

cfx_nc:
       push si
       xor  bx,bx                ; Zeile 0

cfx_nl:
       mov  al,[landscape+si]   ; Aktuelle Hhe holen
       inc  si
       test si,127
       jnz  cfx_ok1
       sub  si,128              ; bertrag verhindern
cfx_ok1:
       mov  ah,bl
       add  ah,al
       sub  ah,[zbuf+bp]
       jng  cfx_nodraw
       add  [zbuf+bp],ah
cfx_vert:
       mov  es:[di],al
       sub  di,320
       dec  ah
       jnz  cfx_vert
cfx_nodraw:
       inc  bl
       cmp  bl,80
       jnz  cfx_nl

       mov  al,0
       mov  ah,118
       sub  ah,[zbuf+bp]
cfx_fill:
       mov  es:[di],al
       sub  di,320
       dec  ah
       jnz  cfx_fill

       add  di,98*320-1         ; 98 Zeilen runter und eins vor
       pop  si
       sub  si,128               ; vorige Zeile im Landschaftarray

       dec  bp                  ; Spalte 98
       jge  cfx_nc

       ret
ENDP


;-----------------------------------------------------------------------
; Funktion        : vert_line
;-----------------------------------------------------------------------
; Info : Zeichnet eine vertikale Linie
;-----------------------------------------------------------------------
; IN  : AL: Farbe der Linie
;       BX: Lnge der Linie
;       CX: X-Koordinate des Startpunkts
;       DX: Y-Koordinate des Startpunkts
; OUT : ---
;-----------------------------------------------------------------------
vert_line PROC
        push ax                 ; Register sichern
        push bx
        push dx

vl_loop:
        mov  ah,0ch             ; Funktion Pixel setzen
        int  10h                ; Interrupt
        inc  dx                 ; nchste Zeile
        dec  bx                 ; Counter verringern
        jnz  vl_loop            ; weiter, wenn noch nicht alle gesetzt

        pop  dx                 ; Register zurckholen
        pop  bx
        pop  ax

        ret

ENDP
;-----------------------------------------------------------------------
; Funktion        : hor_line
;-----------------------------------------------------------------------
; Info : Zeichnet eine horizontale Linie
;-----------------------------------------------------------------------
; IN  : AL: Farbe der Linie
;       BX: Lnge der Linie
;       CX: X-Koordinate des Startpunkts
;       DX: Y-Koordinate des Startpunkts
; OUT : ---
;-----------------------------------------------------------------------
hor_line PROC
        push ax                 ; Register sichern
        push bx
        push cx

hl_loop:
        mov  ah,0ch             ; Funktion Pixel setzen
        int  10h                ; Interrupt
        inc  cx                 ; nchste Zeile
        dec  bx                 ; Counter verringern
        jnz  hl_loop            ; weiter, wenn noch nicht alle gesetzt

        pop  cx                 ; Register zurckholen
        pop  bx
        pop  ax

        ret

ENDP


start:                          ; hier beginnt die Abarbeitung des Programmshier beginnt die
        mov     ax, data        ; Adresse des Daten Segments nach ax
        mov     ds, ax          ; DatenSegment nach ds

        mov     ax,13h          ; switching to Mode 13h (VGA 320x200x256)
        int     10h

        call    palette         ; Palette erstellen

        mov     al,40           ; Farbe 40 (rot)
        mov     bx,100          ; 100 Pixel lang
        mov     cx,110          ; AnfangsPosition der Linie
        mov     dx,50           ; AnfangsPosition der Linie
        call    vert_line       ; Vertikale Linie
        call    hor_line        ; Horizontale Linie
        mov     cx,209          ; AnfangsPosition der Linie
        call    vert_line       ; Horizontale Linie
        mov     cx,110          ; AnfangsPosition der Linie
        mov     dx,149          ; AnfangsPosition der Linie
        call    hor_line        ; Horizontale Linie


        mov     cx,0
mainloop:


        mov     dx,3dah
ml_wait:
        in      al,dx
        test    al,8            ; waiting for V-Retrace
        jz      ml_wait

        mov     si,cx
        call    coolfx          ; Landschaft malen

        inc     cx
        and     cx,127

        mov     ah,01h          ; Tastaturbuffer checken
        int     16h
        jz      mainloop        ; warten bis Taste gedrckt


        mov     ah,00h          ; Tastaturbuffer lesen = lschen
        int     16h

        mov     ax,03h          ; Textmodus
        int     10h

        mov     ax, 4c00h       ; Funktion 4c00h (Programmende)
        int     21h             ; Interuppt auslsen


code ENDS



     end     start              ; Start als Einsprungpunkt definieren

;-----
; EOF
;-----
